diff -urN linux.store/linux/arch/arm/drivers/block/mfmhd.c linux/arch/arm/drivers/block/mfmhd.c
--- linux.store/linux/arch/arm/drivers/block/mfmhd.c	Wed Mar 13 23:55:00 1996
+++ linux/arch/arm/drivers/block/mfmhd.c	Thu Mar 28 15:05:27 1996
@@ -18,7 +18,7 @@
  *              Took interrupt handlers off task queue lists and called
  *                directly - not sure of implications.
  *
- *  18/2/96:DAG: Well its reading OK I think, well enough for image file code
+ * 18/2/96:DAG: Well its reading OK I think, well enough for image file code
  *              to find the image file; but now I've discovered that I actually
  *              have to put some code in for image files.
  *
@@ -36,6 +36,7 @@
 #include <linux/config.h>
 #include <linux/sched.h>
 #include <linux/fs.h>
+#include <linux/interrupt.h>
 #include <linux/kernel.h>
 #include <linux/timer.h>
 #include <linux/tqueue.h>
@@ -61,6 +62,7 @@
 static int frag_count;                             /* Number of fragments to go */
 static int frag_pos;                               /* Position in fragment arrays */
 static unsigned int frag_sectors;
+static unsigned Busy;                              /* We're busy if this is true */
 
 static unsigned int PartFragRead;   /* The number of sectors which have been read
                                        during a partial read split over two
@@ -91,9 +93,9 @@
 static void mfm_interrupt_handler (int, struct pt_regs *);
 static void mfm_seek (void);
 static void mfm_unexpected_interrupt (void);
+static void mfm_rerequest (void);
 static void mfm_request (void);
 static int  mfm_reread_partitions (int dev);
-static void mfm_request (void);
 static void mfm_specify (void);
 
 #define mfm_init xd_init
@@ -111,7 +113,6 @@
 static char mfm_IRQMask;    /* AND with *mfm_IRQPollLoc to find if there is an interrupt */
 static int mfm_drives = 0;	/* drives available */
 static int mfm_status = 0;	/* interrupt status */
-static char mfm_busy = 0;	/* mfm busy */
 static int *errors;
 
 static struct rawcmd
@@ -223,6 +224,27 @@
 #define STAT_POL	0x0200		/* Polling */
 
 /* ------------------------------------------------------------------------------------------ */
+static void console_printf(const char *fmt, ...) {
+  static buffer[2048]; /* Arbitary! */
+  extern void console_print(const char *);
+  va_list ap;
+  int flags;
+
+  save_flags(flags);
+  cli();
+
+  va_start(ap,fmt);
+
+  vsprintf(buffer,fmt,ap);
+
+  console_print(buffer);
+
+  va_end(fmt);
+  
+  restore_flags(flags);
+}; /* console_printf */
+
+/* ------------------------------------------------------------------------------------------ */
 
 static struct gendisk mfm_gendisk = {
 	MAJOR_NR,	/* Major number */
@@ -261,7 +283,8 @@
 /* DAG */
 #ifdef CONFIG_MFM_ONMAINBOARD
   mfm_irq = IRQ_HARDDISK;
-  mfm_addr=(0x3250000>>2); /* Motherboard HDC address  - thats probably slow - what should it be? */
+  mfm_addr=(0x32d0000>>2); /* Motherboard HDC address  - thats medium (as RiscOS)
+                              used to be slow */
   mfm_IRQPollLoc=ioc+0x20;
   mfm_IRQMask=0x08; /* IL3 pin */
 #else
@@ -305,11 +328,13 @@
 	gendisk_head = & mfm_gendisk;
 #endif
 
+  Busy=0;
+
 	return 0;
 }
 
 /* DAG: Gets called by the genhd code to set up the number of sectors etc. */
-void xt_set_geometry(int dev,unsigned char secsptrack,unsigned char heads,
+void xd_set_geometry(int dev,unsigned char secsptrack,unsigned char heads,
                    unsigned long discsize, unsigned int secsize)
 {
   dev=MINOR(dev);
@@ -329,18 +354,18 @@
     printk("mfm%c: %d cylinders, %d heads, %d sectors secsize=%d (%ld total)\n",'a'+(dev>>6),
         mfm_info[dev>>6].cylinders, heads, secsptrack, secsize, discsize);
     /* Should probably do a specify command here....*/
-    printk("mfm: at end of set_hdinfo: About to do a specify\n");
+    console_printf("mfm: at end of set_hdinfo: About to do a specify\n");
     if ((heads<1) || (mfm_drive_param[dev>>6].nocylinders>1024)) {
       /* Shouldn't be a panic - but easiest for initial debug */
       panic("xt_set_hdinfo: Invalid heads/cylinders count\n"); 
     };
     mfm_specify();
-    printk("mfm: set_hdinfo after the specify\n");
+    console_printf("mfm: set_hdinfo after the specify\n");
   };
 
   mfm[dev].start_sect=0;
   mfm[dev].nr_sects=(discsize/secsize)/2; /* This is 512 byte sectors - I want 256 but where does this get set for image files? */
-  printk("mfm set_hdinfo: mfm[%d].nr_sects=%ld\n",dev,mfm[dev].nr_sects);
+  console_printf("mfm set_hdinfo: mfm[%d].nr_sects=%ld\n",dev,mfm[dev].nr_sects);
 
 }
     
@@ -363,14 +388,14 @@
 		printk("mfm%d: heads = %d, cylinders = %d, sectors = %d\n", i,
 			 mfm_info[i].heads, mfm_info[i].cylinders, mfm_info[i].sectors);
 
-  /*printk("mfm: Before irq register\n");*/
+  /*console_printf("mfm: Before irq register\n");*/
 	if(request_irq(mfm_irq, mfm_interrupt_handler, SA_INTERRUPT, "MFM harddisk"))
 		printk("mfm: unable to get IRQ%d\n", mfm_irq);
 
-  /*printk("mfm: Before wierd write\n"); */
+  /*console_printf("mfm: Before wierd write\n"); */
 	/*outw(0x80, mfm_addr + (0x1000 >> 2)); *//* Pardon? DAG */
 
-  /*printk("mfm: Before data init\n");*/
+  /*console_printf("mfm: Before data init\n");*/
 	for(i = 0; i < mfm_drives; i++) {
 		mfm[i << 6].nr_sects = mfm_info[i].heads * mfm_info[i].cylinders *
 				mfm_info[i].sectors;
@@ -379,11 +404,11 @@
 	}
 	mfm_gendisk.nr_real = mfm_drives;
 
-  /*printk("mfm: Before init blocksizes\n");*/
+  /*console_printf("mfm: Before init blocksizes\n");*/
 	for(i=0; i<(XD_MAXDRIVES << 6); i++)
 		mfm_blocksizes[i] = 1024;
 	blksize_size[MAJOR_NR] = mfm_blocksizes;
-  /*printk("mfm: End of init\n");*/
+  /*console_printf("mfm: End of init\n");*/
 }
 
 static int mfm_open (struct inode *inode,struct file *file)
@@ -552,16 +577,16 @@
 	int status;
 #ifdef DEBUG
 	int i;
-	printk("issue_command: %02X: ",command);
+	console_printf("issue_command: %02X: ",command);
 	for(i=0; i<len; i++)
-	  printk("%02X ", cmdb[i]);
-	printk("\n");
+	  console_printf("%02X ", cmdb[i]);
+	console_printf("\n");
 #endif
 
 	do {
 		status = inw(MFM_STATUS);
 	} while(status & (STAT_BSY|STAT_POL));
-  /*printk("issue_command: status after pol/bsy loop: %02X:\n ",status>>8); */
+  /*console_printf("issue_command: status after pol/bsy loop: %02X:\n ",status>>8); */
 	if(status & (STAT_CPR|STAT_CED|STAT_SED|STAT_DER|STAT_ABN))
 	{
 		outw(CMD_RCAL, MFM_COMMAND);
@@ -569,7 +594,7 @@
 	}
 
 	status = inw(MFM_STATUS);
-  /*printk("issue_command: status before parameter issue: %02X:\n ",status>>8);*/
+  /*console_printf("issue_command: status before parameter issue: %02X:\n ",status>>8);*/
 	while(len > 0)
 	{
 		outw(cmdb[1] | (cmdb[0] << 8), MFM_DATAOUT);
@@ -577,11 +602,11 @@
 		cmdb += 2;
 	}
 	status = inw(MFM_STATUS);
-  /*printk("issue_command: status before command issue: %02X:\n ",status>>8);*/
+  /*console_printf("issue_command: status before command issue: %02X:\n ",status>>8);*/
 	outw(command, MFM_COMMAND);
 	status = inw(MFM_STATUS);
-  /*printk("issue_command: status immediatly after command issue: %02X:\n ",status>>8);*/
-  udelay(20);
+  /*console_printf("issue_command: status immediatly after command issue: %02X:\n ",status>>8);*/
+  /*udelay(20);*/
 }
 
 static void wait_for_completion (void)
@@ -593,8 +618,9 @@
 
 static void mfm_rw_intr (void)
 {
+  int old_status; /* Holds status on entry, we read to see if the command just finished */
 #ifdef DEBUG
-	printk("mfm_rw_intr...dataleft=%d\n",hdc63463_dataleft);
+	console_printf("mfm_rw_intr...dataleft=%d\n",hdc63463_dataleft);
   print_status();
 #endif
 
@@ -602,6 +628,9 @@
     /* Something has gone wrong - lets try that again */
     outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
     if (cont) {
+#ifdef DEBUG
+      console_printf("mfm_rw_intr: DER/ABN err\n");
+#endif
       cont->error();
       cont->redo();
     };
@@ -633,20 +662,39 @@
       };
       return;
     };
-    /*printk("Going to try read dma..............status=0x%x\n",mfm_status); */
+    /*console_printf("Going to try read dma..............status=0x%x\n",mfm_status); */
     hdc63463_readdma();
   }; /* Read */
 
+  old_status=mfm_status;
 	mfm_status = inw(MFM_STATUS);
   if (mfm_status & (STAT_DER | STAT_ABN)) {
     /* Something has gone wrong - lets try that again */
     if (cont) {
+#ifdef DEBUG
+      console_printf("mfm_rw_intr: DER/ABN error\n");
+#endif
       cont->error();
       cont->redo();
     };
     return;
   };
 
+  /* If this code wasn't entered due to command_end but there is
+  now a command end we must read the command results out. If it was
+  entered like this then mfm_interrupt_handler would have done the
+  job. */
+  if ((!((old_status & (STAT_CPR|STAT_BSY)) == STAT_CPR)) &&
+      ((mfm_status & (STAT_CPR|STAT_BSY)) == STAT_CPR)) {
+    int len=0;
+    while(len<16)
+    {
+      int in;
+      in = inw(MFM_DATAIN);
+      result[len++] = in>>8;
+      result[len++] = in;
+    };
+  }; /* Result read */
   /* If end of command move on */
   if (mfm_status & (STAT_CED)) {
     outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
@@ -657,7 +705,7 @@
     }
     /*mfm_request(); - DAG - took out because we might not have finished the whole command */
 #ifdef DEBUG
-    printk("mfm_rw_intr: returned from cont->done\n");
+    console_printf("mfm_rw_intr: returned from cont->done\n");
 #endif
   } else {
     /* Its going to generate another interrupt */
@@ -668,7 +716,7 @@
 static void mfm_setup_rw (void)
 {
 #ifdef DEBUG
-	printk("setting up for rw...\n");
+	console_printf("setting up for rw...\n");
 #endif
 #if 1
 	SET_INTR(mfm_rw_intr);
@@ -685,7 +733,7 @@
 static void mfm_recal_intr (void)
 {
 #ifdef DEBUG
-	printk("recal intr - status = ");
+	console_printf("recal intr - status = ");
 	print_status();
 #endif
   outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
@@ -719,7 +767,7 @@
 static void mfm_seek_intr (void)
 {
 #ifdef DEBUG
-	printk("seek intr - status = ");
+	console_printf("seek intr - status = ");
 	print_status();  
 #endif
   outw(CMD_RCAL, MFM_COMMAND);	/* Clear interrupt condition */
@@ -753,7 +801,7 @@
   disc to - on its SECOND call to specify! */
 #define IDEA2
 	unsigned char cmdb[16];
-	printk("specify...\n");
+	console_printf("specify...\n");
 	cmdb[0] = 0x1F; /* OM0 - !SECT,!MOD,!DIF,PADP,ECD,CRCP,CRCI,ACOR */
 	cmdb[1] = 0xC3; /* OM1 - DTM,BRST,!CEDM,!SEDM,!DERM,0,AMEX,PSK */
 #ifndef IDEA2
@@ -788,14 +836,14 @@
 {
 	unsigned char cmdb[4];
 #ifdef DEBUG
-	printk("seeking...\n");
+	console_printf("seeking...\n");
 #endif
 	if(MFM_DRV_PARAM.cylinder < 0) {
 		cmdb[0] = raw_cmd.dev + 1;
 		cmdb[1] = raw_cmd.head;
 
 		SET_INTR(mfm_recal_intr);
-    printk("mfm_seek: about to call specify\n");
+    console_printf("mfm_seek: about to call specify\n");
     mfm_specify(); /* DAG added this */
 		issue_command(CMD_RCLB, cmdb, 2);
 		return;
@@ -818,7 +866,7 @@
 static void mfm_initialise (void)
 {
 #ifdef DEBUG
-	printk("init...\n");
+	console_printf("init...\n");
 #endif
 	if(raw_cmd.flags & NEED_SEEK)
 		mfm_seek();
@@ -831,14 +879,15 @@
 static void request_done(int uptodate)
 {
 	if(!CURRENT) {
-		printk("mfm: request list destroyed\n");
+		console_printf("mfm: request list destroyed\n");
 		return;
 	}
 	if(uptodate) {
     /* Apparently worked - lets check bytes left to DMA */
     if (hdc63463_dataleft!=(PartFragRead_SectorsLeft*256)) {
-      printk("mfm: request_done - dataleft=%d - should be %d\n",hdc63463_dataleft,PartFragRead_SectorsLeft*256);
+      console_printf("mfm: request_done - dataleft=%d - should be %d\n",hdc63463_dataleft,PartFragRead_SectorsLeft*256);
       end_request (0);
+      Busy=0;
     } else {
       /* Potentially this means that we've done; but we might be doing
          a partial access, (over two cylinders) or we may have a number
@@ -864,7 +913,9 @@
         unsigned int dev,block,nsect;
         dev=MINOR(CURRENT->rq_dev);
 
-        printk("mfm: Now about to issue fragment %d\n",frag_pos+1);
+#ifdef DEBUG
+        console_printf("mfm: Now about to issue fragment %d\n",frag_pos+1);
+#endif
         /* OK - time to issue another fragment */
         /* Increment the place where we are going to store the data */
         /* Move onto the next fragment */
@@ -874,13 +925,14 @@
            ask for some more fragments */
         if (frag_pos>=MAX_FRAGS)
         {
-          printk("mfm: Getting another block of fragments\n");
+          console_printf("mfm: Getting another block of fragments\n");
           block=CURRENT->sector*2;
           block+=mfm[dev].start_sect;
           nsect=CURRENT->nr_sectors*2;
           if (!image_file_check(CURRENT->rq_dev,CURRENT->cmd))
           {
             end_request(0);
+            Busy=0;
             /* Should I initiate another request here? */
             return;
           }
@@ -888,6 +940,7 @@
           if (!frag_count)
           {
             end_request(0);
+            Busy=0;
             /* Should I initiate another request here? */
             return;
           };
@@ -902,27 +955,29 @@
       } else {
         /* No - its the end of the line */
         end_request (1);
+        Busy=0;
 
 #ifdef DEBUG
-        printk("request_done: About to mfm_request\n");
+        console_printf("request_done: About to mfm_request\n");
 #endif
         /* Next one please */
         mfm_request(); /* Moved from mfm_rw_intr */
 #ifdef DEBUG
-        printk("request_done: returned from mfm_request\n");
+        console_printf("request_done: returned from mfm_request\n");
 #endif
       }; 
     };
 	}
 	else {
 		end_request (0);
+    Busy=0;
 	}
 }
 
 static void error_handler (void)
 {
 	int i;
-	printk("error detected... status = ");
+	console_printf("error detected... status = ");
 	print_status();
   /*panic("mfm error");*/ /* DAG tmp */
 	(*errors) ++;
@@ -934,13 +989,13 @@
 
 static void rw_interrupt(void)
 {
-  printk("rw_interrupt\n");
+  console_printf("rw_interrupt\n");
 }
 
 static struct cont rw_cont ={
 	rw_interrupt,
 	error_handler,
-	mfm_request,
+	mfm_rerequest,
 	request_done
 };
 
@@ -967,7 +1022,7 @@
     sectors_to_next_cyl+=(mfm_info[dev].sectors-start_sector);
 
 #ifdef DEBUG
-    printk("issue_request: mfm_info[dev].sectors=%d track=%d\n",mfm_info[dev].sectors,track);
+    console_printf("issue_request: mfm_info[dev].sectors=%d track=%d\n",mfm_info[dev].sectors,track);
 #endif
 
 		raw_cmd.flags		= NEED_SEEK;
@@ -1003,7 +1058,7 @@
 
 
 #ifdef DEBUG
-		printk("mfm%c: %sing: CHS=%d/%d/%d, sectors=%d, buffer=0x%08lx (%p)\n",
+		console_printf("mfm%c: %sing: CHS=%d/%d/%d, sectors=%d, buffer=0x%08lx (%p)\n",
 			raw_cmd.dev+'a', (CURRENT->cmd == READ)?"read":"writ",
 			raw_cmd.cylinder,
 			raw_cmd.head,
@@ -1012,41 +1067,69 @@
 		cont = &rw_cont;
 		errors = &(CURRENT->errors);
 		mfm_tq.routine = (void (*)(void *))mfm_initialise;
-		queue_task(&mfm_tq, &tq_timer);
+		queue_task(&mfm_tq, &tq_immediate);
+    mark_bh(IMMEDIATE_BH);
 }; /* issue_request */
 
+static void mfm_rerequest (void)
+{
+  /* Called when an error has just happened - need to trick mfm_request
+     into thinking we weren't busy */
+  /* Turn off ints - mfm_request expects no interrupts anyway */
+#ifdef DEBUG
+  console_printf("mfm_rerequest\n");
+#endif
+  cli();
+  Busy=0;
+  mfm_request();
+};
+
 static void mfm_request (void)
 {
 	unsigned int dev, block, nsect;
 
 #ifdef DEBUG
-  printk("mfm_request CURRENT=%p\n",CURRENT);
+  console_printf("mfm_request CURRENT=%p Busy=%d\n",CURRENT,Busy);
 #endif
+  if (!CURRENT) return;
+  /* If we are still processing then return; we will get called again */
+  if (Busy) return;
+  Busy=1;
+
 	if(CURRENT && CURRENT->rq_dev < 0) {
-    printk("mfm_request: exit due to (CURRENT && CURRENT->rq_dev < 0)\n");
+    console_printf("mfm_request: exit due to (CURRENT && CURRENT->rq_dev < 0)\n");
+    Busy=0;
 		return;
   };
 
 	while(1){
 #ifdef DEBUG
-    printk("mfm_request: loop start\n");
+    console_printf("mfm_request: loop start\n");
 #endif
     /* DAG: I wonder if there wshould be a store flags here? */
 		sti();
 
 #ifdef DEBUG
-    printk("mfm_request: before INIT_REQUEST\n");
+    console_printf("mfm_request: before INIT_REQUEST\n");
 #endif
 		INIT_REQUEST;
+
+    /* DAG: Should this be here - e.g. if we run out of valid requests */
+    if (!CURRENT) {
+      console_printf("mfm_request: Exiting due to !CURRENT\n");
+      Busy=0;
+      return;
+    };
+
 #ifdef DEBUG
-    printk("mfm_request: before arg extraction\n");
+    console_printf("mfm_request: before arg extraction\n");
 #endif
 		dev = MINOR(CURRENT->rq_dev);
 		block = CURRENT->sector;
 		nsect = CURRENT->nr_sectors;
 
 #ifdef DEBUG
-    printk("mfm_request: raw vals: dev=%d block=%d nsect=%d\n",dev,block,nsect);
+    console_printf("mfm_request: raw vals: dev=%d block=%d nsect=%d\n",dev,block,nsect);
 #endif
 
     /* DAG: Linux doesn't cope with this - even though it has an array telling
@@ -1064,6 +1147,7 @@
 				printk("mfm%c: bad access: block=%d, count=%d\n", (dev>>6)+'a',
 					block, nsect);
 			end_request(0);
+      Busy=0;
 			continue;
 		}
 		block += mfm[dev].start_sect;
@@ -1081,6 +1165,12 @@
       block=frag_start[0]*2;
       frag_sectors=nsect=frag_len[0]*2;
       frag_pos=0;
+#ifdef DEBUG
+      if (frag_count>1) {
+        console_printf("Multiple fragments rq_dev=%d block=%d nsect=%d frag_start[0]=%d frag_len[0]=%d\n",
+               CURRENT->rq_dev,block,nsect,frag_start[0],frag_len[0]);
+      };
+#endif
     } else {
       /* OK - its not an image file - lets just push it through */
       frag_pos=0;
@@ -1092,17 +1182,19 @@
          /* Stop writing to the raw drive */
          printk("mfm%d: attempted write on protected drive\n",dev);
          end_request(0);
+         Busy=0;
          continue;
       };
     }; /* image file/normal if */
 #ifdef DEBUG
-    printk("mfm_request: block after offset=%d\n",block);
+    console_printf("mfm_request: block after offset=%d\n",block);
 #endif
 
 		if(CURRENT->cmd != READ && CURRENT->cmd != WRITE)
 		{
 			printk("unknown mfm-command %d\n", CURRENT->cmd);
 			end_request(0);
+      Busy=0;
 			continue;
 		}
 
@@ -1111,14 +1203,14 @@
 		break;
 	}
 #ifdef DEBUG
-  printk("mfm_request: Dropping out bottom\n");
+  console_printf("mfm_request: Dropping out bottom\n");
 #endif
 }
 
 static void do_mfm_request (void)
 {
 #ifdef DEBUG
-  printk("do_mfm_request: about to mfm_request\n");
+  console_printf("do_mfm_request: about to mfm_request\n");
 #endif
 	mfm_request();
 }
@@ -1136,7 +1228,7 @@
 	void (*handler)(void) = DEVICE_INTR;
 
 #ifdef DEBUG
-  printk("mfm_interrupt_handler (handler=0x%p)\n",handler);
+  console_printf("mfm_interrupt_handler (handler=0x%p)\n",handler);
 #endif
 	CLEAR_INTR;
 	mfm_status = inw(MFM_STATUS);
@@ -1161,8 +1253,6 @@
 		mfm_unexpected_interrupt();
 		return;
 	}
-	/*mfm_tq.routine = (void (*)(void *))handler;
-	queue_task_irq(&mfm_tq, &tq_timer); */
   handler();
 }
 
diff -urN linux.store/linux/arch/arm/drivers/char/Makefile linux/arch/arm/drivers/char/Makefile
--- linux.store/linux/arch/arm/drivers/char/Makefile	Wed Mar 13 23:55:00 1996
+++ linux/arch/arm/drivers/char/Makefile	Thu Mar 28 14:16:17 1996
@@ -93,8 +93,12 @@
 	done
 	touch links
 
-LINKCLEAN:
+mrproper:
 	-@for f in $(LK); do \
-		if [ -L $$f ]; then rm -f $$f; fi; \
+		if [ -L $$f ]; then \
+			echo $(RM) $$f; \
+			$(RM) $$f; \
+		fi; \
 	done
-	rm -f links
+	$(RM) links
+	$(RM) conmakehash
diff -urN linux.store/linux/arch/arm/drivers/char/console.c linux/arch/arm/drivers/char/console.c
--- linux.store/linux/arch/arm/drivers/char/console.c	Wed Mar 13 23:55:01 1996
+++ linux/arch/arm/drivers/char/console.c	Thu Mar 28 14:21:29 1996
@@ -1818,7 +1818,7 @@
 	}
 }
 
-static void console_print(const char *b)
+void console_print(const char *b)
 {
 	int currcons = fg_console;
 	unsigned char c;
diff -urN linux.store/linux/arch/arm/drivers/char/iic.c linux/arch/arm/drivers/char/iic.c
--- linux.store/linux/arch/arm/drivers/char/iic.c	Sun Mar  3 12:33:06 1996
+++ linux/arch/arm/drivers/char/iic.c	Fri Mar 22 21:53:55 1996
@@ -9,8 +9,7 @@
 #include <asm/system.h>
 #include <asm/delay.h>
 #include <asm/io.h>
-
-extern unsigned char volatile *const ioc;
+#include <asm/hardware.h>
 
 #define DELAY udelay(10)
 
@@ -18,12 +17,12 @@
 {
     unsigned char out;
 
-    out = ioc[0] | 0xc2;
+    out = IOC_CONTROL | 0xc2;
 
-    ioc[0] = out;
+    IOC_CONTROL = out;
     DELAY;
 
-    ioc[0] = out ^ 1;
+    IOC_CONTROL = out ^ 1;
     DELAY;
 }
 
@@ -31,13 +30,13 @@
 {
     unsigned char out;
 
-    out = ioc[0] | 0xc3;
+    out = IOC_CONTROL | 0xc3;
 
     DELAY;
-    ioc[0] = out ^ 1;
+    IOC_CONTROL = out ^ 1;
 
     DELAY;
-    ioc[0] = out;
+    IOC_CONTROL = out;
 }
 
 static int iic_sendbyte (unsigned char b)
@@ -45,30 +44,30 @@
     unsigned char out, in;
     int i;
 
-    out = (ioc[0] & 0xFC) | 0xC0;
+    out = (IOC_CONTROL & 0xFC) | 0xC0;
 
-    ioc[0] = out;
+    IOC_CONTROL = out;
     for (i = 7; i >= 0; i--) {
-	ioc[0] = out | ((b & (1 << i)) ? 1 : 0);
+	IOC_CONTROL = out | ((b & (1 << i)) ? 1 : 0);
 	DELAY;
 
-	ioc[0] = out | ((b & (1 << i)) ? 1 : 0) | 2;
+	IOC_CONTROL = out | ((b & (1 << i)) ? 1 : 0) | 2;
 	DELAY;
 
-	ioc[0] = out | ((b & (1 << i)) ? 1 : 0);
+	IOC_CONTROL = out | ((b & (1 << i)) ? 1 : 0);
     }
-    ioc[0] = out | 1;
+    IOC_CONTROL = out | 1;
     DELAY;
 
-    ioc[0] = out | 3;
+    IOC_CONTROL = out | 3;
     DELAY;
 
-    in = ioc[0] & 1;
+    in = IOC_CONTROL & 1;
 
-    ioc[0] = out | 1;
+    IOC_CONTROL = out | 1;
     DELAY;
 
-    ioc[0] = out;
+    IOC_CONTROL = out;
     DELAY;
 
     if(in) {
@@ -83,25 +82,25 @@
     unsigned char out, in;
     int i;
 
-    out = (ioc[0] & 0xFC) | 0xC0;
+    out = (IOC_CONTROL & 0xFC) | 0xC0;
 
-    ioc[0] = out;
+    IOC_CONTROL = out;
     in = 0;
     for (i = 7; i >= 0; i--) {
-	ioc[0] = out | 1;
+	IOC_CONTROL = out | 1;
 	DELAY;
 
-	ioc[0] = out | 3;
+	IOC_CONTROL = out | 3;
 	DELAY;
 
-	in = (in << 1) | (ioc[0] & 1);
-	ioc[0] = out | 1;
+	in = (in << 1) | (IOC_CONTROL & 1);
+	IOC_CONTROL = out | 1;
 	DELAY;
     }
-    ioc[0] = out;
+    IOC_CONTROL = out;
     DELAY;
 
-    ioc[0] = out | 2;
+    IOC_CONTROL = out | 2;
     DELAY;
 
     return in;
diff -urN linux.store/linux/arch/arm/drivers/char/keyboard.c linux/arch/arm/drivers/char/keyboard.c
--- linux.store/linux/arch/arm/drivers/char/keyboard.c	Wed Mar 13 23:55:03 1996
+++ linux/arch/arm/drivers/char/keyboard.c	Fri Mar 22 21:59:21 1996
@@ -37,6 +37,7 @@
 
 #include <asm/bitops.h>
 #include <asm/irq.h>
+#include <asm/hardware.h>
 
 #include "kbd_kern.h"
 #include "diacr.h"
@@ -216,8 +217,7 @@
 static unsigned char	kbd_sendptri;
 static unsigned char	kbd_sendptro;
 static unsigned char    ledstate = 0xff;
-static unsigned char getleds(void);
-extern unsigned char	*ioc;
+static unsigned char	getleds(void);
 
 /*
  * This array converts the scancode that we get from the keyboard to the
@@ -533,7 +533,7 @@
 
     pt_regs = regs;
 
-    keyval=ioc[4];
+    keyval = IOC_KARTRX;
 
     switch(kbd_state) {
     case 0:/* initial reset condition */
@@ -656,15 +656,13 @@
 
 static void kbd_tx(int irq, struct pt_regs *regs)
 {
-  if(kbd_sendptri!=kbd_sendptro)
-  {
-    ioc[0x04]=kbd_sendvala[kbd_sendptro];
-    kbd_sendptro=(kbd_sendptro+1)&3;
+  if(kbd_sendptri != kbd_sendptro) {
+    IOC_KARTTX = kbd_sendvala[kbd_sendptro];
+    kbd_sendptro = (kbd_sendptro + 1) & 3;
   }
-  if(kbd_sendptri==kbd_sendptro)
-  {
-    disable_irq(14);
-    enable_irq(15);
+  if(kbd_sendptri == kbd_sendptro) {
+    disable_irq (14);
+    enable_irq (15);
   }
 }
 
diff -urN linux.store/linux/arch/arm/drivers/net/Makefile linux/arch/arm/drivers/net/Makefile
--- linux.store/linux/arch/arm/drivers/net/Makefile	Sat Feb 24 21:37:51 1996
+++ linux/arch/arm/drivers/net/Makefile	Thu Mar 28 12:04:14 1996
@@ -148,8 +148,12 @@
 	done
 	touch links
 
-LINKCLEAN:
+mrproper:
 	-@for f in $(LK); do \
-		if [ -L $$f ]; then rm $$f; fi; \
+		if [ -L $$f ]; then \
+			echo $(RM) $$f; \
+			$(RM) $$f; \
+		fi; \
 	done
-	rm -f links
+	$(RM) links
+	$(RM) ppp.ver
diff -urN linux.store/linux/arch/arm/drivers/net/ether1.c linux/arch/arm/drivers/net/ether1.c
--- linux.store/linux/arch/arm/drivers/net/ether1.c	Thu Mar 14 11:43:03 1996
+++ linux/arch/arm/drivers/net/ether1.c	Tue Mar 26 23:16:37 1996
@@ -15,6 +15,12 @@
  * all the time, we have to be careful when we modify the pointers etc
  * so that the buffer memory is valid all the time.
  */
+
+/*
+ * Change log:
+ * 1.00	RMK			Released
+ * 1.01	RMK	   19/03/96	Transfers the last odd byte onto/off of the card now.
+ */
 #ifdef MODULE
 #include <linux/module.h>
 #include <linux/version.h>
@@ -55,15 +61,15 @@
 #define FUNC_PROLOGUE \
 	struct ether1_priv *priv = (struct ether1_priv *)dev->priv
 
-#define BUFFER_SIZE	65536
-#define TX_AREA_START	0x0100
-#define TX_AREA_END	0x5000
-#define RX_AREA_START	0x5000
-#define RX_AREA_END	0xfc00
+#define BUFFER_SIZE	0x10000
+#define TX_AREA_START	0x00100
+#define TX_AREA_END	0x05000
+#define RX_AREA_START	0x05000
+#define RX_AREA_END	0x0fc00
 
 #define tx_done(dev) 0
 /* ------------------------------------------------------------------------- */
-static char *version = "ether1 ethernet driver (c) 1995 Russell King V1.00\n";
+static char *version = "ether1 ethernet driver (c) 1995 Russell King v1.01\n";
 
 #define BUS_16 16
 #define BUS_8  8
@@ -122,8 +128,28 @@
     "	mov	%0, %0, lsr #8\n"
     "	strb	%0, [%2], #1\n"
     "	subs	%3, %3, #2\n"
+    "	bmi	2f\n"
+    "	ldr	%0, [%1], #4\n"
+    "	strb	%0, [%2], #1\n"
+    "	mov	%0, %0, lsr #8\n"
+    "	strb	%0, [%2], #1\n"
+    "	subs	%3, %3, #2\n"
+    "	bmi	2f\n"
+    "	ldr	%0, [%1], #4\n"
+    "	strb	%0, [%2], #1\n"
+    "	mov	%0, %0, lsr #8\n"
+    "	strb	%0, [%2], #1\n"
+    "	subs	%3, %3, #2\n"
+    "	bmi	2f\n"
+    "	ldr	%0, [%1], #4\n"
+    "	strb	%0, [%2], #1\n"
+    "	mov	%0, %0, lsr #8\n"
+    "	strb	%0, [%2], #1\n"
+    "	subs	%3, %3, #2\n"
     "	bpl	1b\n"
-    "2:"
+    "2:	adds	%3, %3, #1\n"
+    "	ldreqb	%0, [%1]\n"
+    "	streqb	%0, [%2]\n"
     : "=&r" (used), "=&r" (addr), "=&r" (data), "=&r" (len)
     : "1" (addr << 2), "2" (data), "3" (len));
 
@@ -143,8 +169,28 @@
     "	orr	%0, %0, %0, lsr #16\n"
     "	str	%0, [%1], #4\n"
     "	subs	%3, %3, #2\n"
+    "	bmi	2f\n"
+    "	ldr	%0, [%2], #2\n"
+    "	mov	%0, %0, lsl #16\n"
+    "	orr	%0, %0, %0, lsr #16\n"
+    "	str	%0, [%1], #4\n"
+    "	subs	%3, %3, #2\n"
+    "	bmi	2f\n"
+    "	ldr	%0, [%2], #2\n"
+    "	mov	%0, %0, lsl #16\n"
+    "	orr	%0, %0, %0, lsr #16\n"
+    "	str	%0, [%1], #4\n"
+    "	subs	%3, %3, #2\n"
+    "	bmi	2f\n"
+    "	ldr	%0, [%2], #2\n"
+    "	mov	%0, %0, lsl #16\n"
+    "	orr	%0, %0, %0, lsr #16\n"
+    "	str	%0, [%1], #4\n"
+    "	subs	%3, %3, #2\n"
     "	bpl	1b\n"
-    "2:"
+    "2:	adds	%3, %3, #1\n"
+    "	ldreqb	%0, [%2]\n"
+    "	streqb	%0, [%1]\n"
     : "=&r" (used), "=&r" (addr), "=&r" (data), "=&r" (len)
     : "1" (addr << 2), "2" (data), "3" (len));
 
@@ -436,6 +482,7 @@
 
     /* release reset & give 586 a prod */
     priv->resetting = 1;
+    priv->initialising = 1;
     outb (CTRL_RST, REG_CONTROL);
     outb (0, REG_CONTROL);
     outb (CTRL_CA, REG_CONTROL);
@@ -490,7 +537,7 @@
     }
 
     i += HZ;
-    while (((status = ether1_inw (dev, TDR_ADDR, tdr_t, tdr_status, DISABLE_IRQS))
+    while (((status = ether1_inw (dev, TDR_ADDR, tdr_t, tdr_status, DISABLEIRQS))
 		& STAT_COMPLETE) == 0) {
 	if (jiffies > i)
 	    break;
@@ -596,7 +643,7 @@
     if ((ec = ecard_find (0, sizeof (ether1_prods) / sizeof (int), ether1_prods, ether1_manus)) == NULL)
 	return ENODEV;
 
-    dev->base_addr = (((unsigned long)ec->r_podaddr & ~0x3c0000) + 0x340000) >> 2;
+    dev->base_addr = (((unsigned long)ecard_address (ec->slot_no, ECARD_IOC, ECARD_FAST)) >> 2;
     dev->irq       = ec->irq;
 
     ecard_claim (ec);
@@ -637,15 +684,35 @@
     return start;
 }
 
+static void
+ether1_restart (struct device *dev, char *reason)
+{
+    FUNC_PROLOGUE;
+    priv->stats.tx_errors ++;
+
+    if (reason)
+	printk ("%s: %s - resetting device\n", dev->name, reason);
+    else
+	printk (" - resetting device\n");
+
+    ether1_reset (dev);
+
+    dev->start = 0;
+    dev->tbusy = 0;
+
+    if (ether1_init_for_open (dev))
+	printk ("%s: unable to restart interface\n", dev->name);
+
+    dev->start = 1;
+}
+
 static int
 ether1_open (struct device *dev)
 {
     FUNC_PROLOGUE;
 #ifdef CLAIM_IRQ_AT_OPEN
-    if (request_irq (dev->irq, ether1_interrupt, 0, "ether1")) {
-	kfree (dev->priv);
+    if (request_irq (dev->irq, ether1_interrupt, 0, "ether1"))
 	return -EAGAIN;
-    }
 
     irq2dev_map[dev->irq] = dev;
 #endif
@@ -653,7 +720,14 @@
 
     memset (&priv->stats, 0, sizeof (struct enet_statistics));
 
-    ether1_init_for_open (dev);
+    if (ether1_init_for_open (dev)) {
+#ifdef CLAIM_IRQ_AT_OPEN
+	free_irq (dev->irq);
+	irq2dev_map[dev->irq] = NULL;
+#endif
+	MOD_DEC_USE_COUNT;
+	return -EAGAIN;
+    }
 
     dev->tbusy = 0;
     dev->interrupt = 0;
@@ -677,10 +751,12 @@
 	if (tickssofar < 5)
 	    return 1;
 
-	printk ("%s: transmit timeout, network cable problem?\n", dev->name);
-
 	/* Try to restart the adapter. */
+	ether1_restart (dev, "transmit timeout, network cable problem?");
+#if 0
+	printk ("%s: transmit timeout, network cable problem?\n", dev->name);
 	dev->tbusy = 0;
+#endif
 	dev->trans_start = jiffies;
     }
 
@@ -780,7 +856,10 @@
 
     case CMD_NOP:
 	if (nop.nop_link == caddr) {
-	    printk ("%s: strange command complete with no tx command!\n", dev->name);
+	    if (priv->initialising == 0)
+		printk ("%s: strange command complete with no tx command!\n", dev->name);
+	    else
+	        priv->initialising = 0;
 	    return;
 	}
 	caddr = nop.nop_link;
@@ -789,11 +868,13 @@
     case CMD_TX:
 	if (nop.nop_status & STAT_COMPLETE)
 	    break;
-	printk ("%s: strange command complete without completed command!\n", dev->name);
+	ether1_restart (dev, "strange command complete without completed command!");
 	return;
 
     default:
-	printk ("%s: strange command %d complete!\n", dev->name, nop.nop_command & CMD_MASK);
+	printk ("%s: strange command %d complete! (offset %04X)", dev->name,
+		nop.nop_command & CMD_MASK, caddr);
+	ether1_restart (dev, NULL);
 	return;
     }
 
@@ -1031,7 +1112,7 @@
 	memset (my_ethers[i], 0, sizeof (struct device));
 
 	my_ethers[i]->irq = ec[i]->irq;
-	my_ethers[i]->base_addr = (((unsigned long)ec[i]->r_podaddr & ~0x3c0000) + 0x340000) >> 2;
+	my_ethers[i]->base_addr = (((unsigned long)ecard_address (ec[i]->slot_no, ECARD_IOC, ECARD_FAST)) >> 2;
 	my_ethers[i]->init = ether1_probe;
 	my_ethers[i]->name = ethernames[i];
 
diff -urN linux.store/linux/arch/arm/drivers/net/ether1.h linux/arch/arm/drivers/net/ether1.h
--- linux.store/linux/arch/arm/drivers/net/ether1.h	Sat Feb 17 10:05:58 1996
+++ linux/arch/arm/drivers/net/ether1.h	Wed Mar 20 10:17:11 1996
@@ -39,6 +39,7 @@
 	volatile int rx_tail;
 	char bus_type;
 	char resetting;
+	char initialising;
 };
 
 static int ether1_open (struct device *dev);
diff -urN linux.store/linux/arch/arm/drivers/net/ether3.c linux/arch/arm/drivers/net/ether3.c
--- linux.store/linux/arch/arm/drivers/net/ether3.c	Wed Mar 13 23:55:05 1996
+++ linux/arch/arm/drivers/net/ether3.c	Fri Mar 22 23:23:05 1996
@@ -407,7 +407,7 @@
     if ((ec = ecard_find (0, sizeof(ether3_prods), ether3_prods, ether3_manus)) == NULL)
 	return ENODEV;
 
-    dev->base_addr = ((unsigned long)ec->r_podaddr & ~0x003c0000UL) >> 2;
+    dev->base_addr = ((unsigned long)ecard_address (ec->slot_no, ECARD_MEMC, 0)) >> 2;
     dev->irq = ec->irq;
 
     ecard_claim (ec);
@@ -874,7 +874,7 @@
 	memset(my_ethers[i], 0, sizeof(struct device));
 
 	my_ethers[i]->irq = ec[i]->irq;
-	my_ethers[i]->base_addr= ((unsigned long)ec[i]->r_podaddr & ~0x003c0000UL)>>2;
+	my_ethers[i]->base_addr= ((unsigned long)ecard_address (ec[i]->slot_no, ECARD_MEMC, 0))>>2;
 	my_ethers[i]->init = ether3_probe1;
 	my_ethers[i]->name = ethernames[i];
 
